base/urls.py
from django.conf.urls import url

from base.views import homepage

urlpatterns = [
    url(r'^$', homepage, name='home'),
]

finem_imperii/urls.py
from django.conf.urls import url, include
from django.contrib import admin

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^', include('base.urls', namespace='base'), name='base'),
    url(r'^', include('account.urls', namespace='account'), name='account'),
    url(r'^', include('world.urls', namespace='world'), name='world'),
    url(r'^character/', include('character.urls', namespace='character'), name='character'),
    url(r'^unit/', include('unit.urls', namespace='unit'), name='unit'),
    url(r'^messaging/', include('messaging.urls', namespace='messaging'), name='messaging'),
    url(r'^organization/', include('organization.urls', namespace='organization'), name='organization'),
    url(r'^battle/', include('battle.urls', namespace='battle'), name='battle'),
    url(r'^help/', include('help.urls', namespace='help'), name='help'),
]

messaging/urls.py
from django.conf.urls import url

from decorators import inchar_required
from messaging.views.compose import ComposeView
from messaging.views.contacts import add_contact, remove_contact
from messaging.views.markings import mark_all_read, mark_read, \
    mark_favourite
from messaging.views.message_lists import messages_list, home, \
    favourites_list, sent_list
from messaging.views.reply import reply

urlpatterns = [
    url(r'^$', home, name='home'),
    url(r'^read/(?P<recipient_id>[0-9]+)$', mark_read, name='mark_read'),
    url(r'^favourite/(?P<recipient_id>[0-9]+)$', mark_favourite, name='mark_favourite'),
    url(r'^read_all$', mark_all_read, name='mark_all_read'),
    url(r'^all$', messages_list, name='messages_list'),
    url(r'^favourites$', favourites_list, name='favourites'),
    url(r'^sent', sent_list, name='sent'),
    url(r'^compose$', inchar_required(ComposeView.as_view()), name='compose'),
    url(r'^compose/character/(?P<character_id>[0-9]+)$', inchar_required(ComposeView.as_view()), name='compose_character'),
    url(r'^reply/(?P<recipient_id>[0-9]+)$', reply, name='reply'),
    url(r'^favourite/character/(?P<character_id>[0-9]+)$', add_contact, name='add_contact'),
    url(r'^unfavourite/character/(?P<character_id>[0-9]+)$', remove_contact, name='remove_contact'),
]

base/models.py
from django.db import models

# Create your models here.

messaging/models.py
from django.db import models
from django.urls.base import reverse
from django.utils.html import format_html


class ServerMOTD(models.Model):
    class Meta:
        ordering = ['display_order']

    title = models.TextField()
    html_content = models.TextField()
    display_order = models.SmallIntegerField()
    draft = models.BooleanField(default=True)

    def get_html_content(self):
        return format_html(self.html_content)

    def __str__(self):
        return self.title


class CharacterMessage(models.Model):
    class Meta:
        ordering = ['creation_time']

    TRAVEL = 'travel'
    CONQUEST = 'conquest'
    TURN = 'turn'
    PROPOSAL = 'proposal'
    BATTLE = 'battle'
    POLICY = 'policy'
    BAN = 'ban'
    ELECTIONS = 'elections'
    DIPLOMACY = 'diplomacy'
    MILITARY_STANCE = 'military stance'
    BATTLE_FORMATION = 'battle formation'
    GUILDS = 'guilds'
    UNIT = 'unit'
    WELCOME = 'welcome'
    HEIR = 'heir'
    LEAVE = 'leaving'
    TAXES = 'taxes'
    NEWCOMER = 'newcomer'
    PAUSE = 'pause'
    CASH = 'cash transfer'
    CATEGORY_CHOICES = (
        (TRAVEL, TRAVEL),
        (CONQUEST, CONQUEST),
        (TURN, "new turn"),
        (PROPOSAL, "action proposal"),
        (BATTLE, BATTLE),
        (POLICY, "policy and law"),
        (BAN, "ban"),
        (ELECTIONS, "elections"),
        (DIPLOMACY, "diplomacy"),
        (MILITARY_STANCE, "military stance"),
        (BATTLE_FORMATION, "battle formation"),
        (CONQUEST, "conquest"),
        (GUILDS, "guilds"),
        (UNIT, "unit"),
        (WELCOME, "welcome"),
        (HEIR, "heir"),
        (LEAVE, "leaving"),
        (TAXES, "taxes"),
        (NEWCOMER, "newcomer"),
        (PAUSE, "pause"),
        (CASH, "cash transfer"),
    )

    content = models.TextField()
    creation_time = models.DateTimeField(auto_now_add=True)
    creation_turn = models.IntegerField()
    sender = models.ForeignKey(
        'character.Character', related_name='messages_sent', blank=True, null=True)
    category = models.CharField(
        max_length=20, choices=CATEGORY_CHOICES, blank=True, null=True)
    link = models.TextField(blank=True, null=True)

    def get_nice_recipient_list(self):
        return (
            [group.organization for group in
             self.messagerecipientgroup_set.all()]
            +
            [recipient.character for recipient in
             self.messagerecipient_set.filter(group=None)]
        )

    def get_post_recipient_list(self):
        return (
            ["organization_{}".format(group.organization.id) for group in
             self.messagerecipientgroup_set.all()]
            +
            ["character_{}".format(recipient.character.id) for recipient in
             self.messagerecipient_set.filter(group=None)]
        )


class MessageRecipientGroup(models.Model):
    class Meta:
        unique_together = (
            ("message", "organization"),
        )

    message = models.ForeignKey(CharacterMessage)
    organization = models.ForeignKey('organization.Organization')


class MessageRecipient(models.Model):
    class Meta:
        unique_together = (
            ("message", "character"),
        )
        index_together = (
            ("character", "read"),
        )

    message = models.ForeignKey(CharacterMessage)
    group = models.ForeignKey(MessageRecipientGroup, blank=True, null=True)
    read = models.BooleanField(default=False)
    character = models.ForeignKey('character.Character')
    favourite = models.BooleanField(default=False)

    def get_mark_read_url(self):
        return reverse('messaging:mark_read',
                       kwargs={'recipient_id': self.id})

    def get_mark_favourite_url(self):
        return reverse('messaging:mark_favourite',
                       kwargs={'recipient_id': self.id})


class MessageRelationship(models.Model):
    class Meta:
        unique_together = (
            ("from_character", "to_character"),
        )

    from_character = models.ForeignKey('character.Character')
    to_character = models.ForeignKey(
        'character.Character', related_name='message_relationships_to')

base/views.py
from django.shortcuts import render, redirect

from messaging.models import ServerMOTD


def homepage(request):
    if request.user.is_authenticated():
        return redirect('account:home')
    else:
        context = {
            'server_messages': ServerMOTD.objects.all() if request.user.is_staff
                               else ServerMOTD.objects.filter(draft=False),
        }
        return render(request, "base/homepage.html", context=context)

messaging/views/compose.py
from django.contrib import messages
from django.db import transaction
from django.shortcuts import get_object_or_404, render, redirect
from django.views import View

from character.models import Character
from messaging.models import MessageRecipient
from messaging.shortcuts import create_message, add_recipients_for_reply, \
    add_character_recipient, add_organization_recipient
from organization.models.organization import Organization


class ComposeException(Exception):
    pass


def test_message_body_present(message_body):
    if not message_body:
        raise ComposeException('Please write some message')


def test_message_body_length(message_body):
    if len(message_body) > 10000:
        raise ComposeException(
            'This message is too long (max 10000 characters allowed)'
        )


def test_recipient_present(request, reply_to):
    if not reply_to and not request.POST.getlist('recipient'):
        raise ComposeException(
            'You must choose at least one recipient'
        )


def create_recipients_from_post_data(request, message):
    raw_recipients = request.POST.getlist('recipient')
    organization_count = 0
    character_count = 0

    for raw_recipient in raw_recipients:
        split = raw_recipient.split('_')

        if split[0] == 'settlement':
            for character in request.hero.location.character_set.filter(
                    paused=False):
                character_count += 1
                add_character_recipient(message, character)
        elif split[0] == 'region':
            for character in Character.objects.filter(
                    location__tile=request.hero.location.tile,
                    paused=False):
                character_count += 1
                add_character_recipient(message, character)
        elif split[0] == 'organization':
            organization_count += 1
            organization = get_object_or_404(Organization, id=split[1])
            add_organization_recipient(message, organization)
        elif split[0] == 'character':
            character_count += 1
            character = get_object_or_404(Character, id=split[1])
            add_character_recipient(message, character)
        else:
            message.delete()
            raise ComposeException("Invalid recipient")

    if organization_count > 4 or character_count > 40:
        message.delete()
        raise ComposeException("Too many recipients")


class ComposeView(View):
    def get(self,
            request, character_id=None, prefilled_text='', reply_to=None):
        if character_id:
            target_character = get_object_or_404(
                Character, id=character_id, world=request.hero.world)
        else:
            target_character = None

        context = {
            'reply_to': reply_to,
            'prefilled_text': prefilled_text,
            'tab': 'compose',
            'target_character': target_character,
        }
        return render(request, 'messaging/compose.html', context)

    @transaction.atomic
    def post(self, request):
        message_body = request.POST.get('message_body')
        reply_to = (
            get_object_or_404(
                MessageRecipient,
                id=request.POST.get('reply_to'),
                character=request.hero
            )
            if request.POST.get('reply_to') else None
        )

        try:
            test_message_body_present(message_body)
            test_message_body_length(message_body)
            test_recipient_present(request, reply_to)

            message = create_message(
                template='messaging/messages/character_written_message.html',
                world=request.hero.world,
                category=None,
                template_context={'content': message_body},
                sender=request.hero
            )

            if reply_to:
                add_recipients_for_reply(message, reply_to)
            else:
                create_recipients_from_post_data(request, message)

            messages.success(request, "Message sent.", "success")
            return redirect('messaging:sent')

        except ComposeException as e:
            return self.fail_post_gracefully(
                request,
                reply_to,
                message_body,
                error_message=str(e)
            )

    def fail_post_gracefully(
            self, request, reply_to, prefilled_body, error_message):
        messages.error(request, error_message, "danger")
        return self.get(request, None, prefilled_body, reply_to)

messaging/views/contacts.py
from django.contrib import messages
from django.shortcuts import get_object_or_404, redirect
from django.urls import reverse

from base.utils import redirect_back
from character.models import Character
from decorators import inchar_required
from messaging.models import MessageRelationship


@inchar_required
def add_contact(request, character_id):
    target_character = get_object_or_404(
        Character, id=character_id, world=request.hero.world)
    created = MessageRelationship.objects.get_or_create(
        from_character=request.hero, to_character=target_character)[1]
    if created:
        messages.success(request, "Character added to contacts", "success")
    return redirect_back(request, reverse('character:character_home'))


@inchar_required
def remove_contact(request, character_id):
    target_character = get_object_or_404(
        Character, id=character_id, world=request.hero.world)
    try:
        target_relationship = MessageRelationship.objects.get(
            from_character=request.hero, to_character=target_character)
        target_relationship.delete()
        messages.success(request, "Character removed contacts", "success")
    except MessageRelationship.DoesNotExist:
        pass
    return redirect_back(request, reverse('character:character_home'))

messaging/views/decorators.py
from django.shortcuts import get_object_or_404

from decorators import inchar_required
from messaging.models import MessageRecipient


def recipient_required_decorator(func):
    @inchar_required
    def inner(*args, **kwargs):
        recipient_id = kwargs.get('recipient_id')
        args[0].recipient = get_object_or_404(
            MessageRecipient, id=recipient_id, character=args[0].hero)
        return func(*args, **kwargs)
    return inner

messaging/views/markings.py
from django.shortcuts import redirect
from django.urls import reverse

from base.utils import redirect_back
from decorators import inchar_required
from messaging.models import MessageRecipient
from messaging.views.decorators import recipient_required_decorator


@inchar_required
def mark_all_read(request):
    MessageRecipient.objects.filter(
        character=request.hero, read=False).update(read=True)
    return redirect_back(request, reverse('character:character_home'))


@recipient_required_decorator
def mark_read(request, recipient_id):
    request.recipient.read = not request.recipient.read
    request.recipient.save()
    return redirect_back(request, reverse('messaging:home'))


@recipient_required_decorator
def mark_favourite(request, recipient_id):
    request.recipient.favourite = not request.recipient.favourite
    request.recipient.save()
    return redirect_back(request, reverse('messaging:home'))

messaging/views/message_lists.py
from django.shortcuts import render

from decorators import inchar_required


@inchar_required
def generic_message_list(request, tab, recipient_list,
                         template='messaging/message_list.html'):
    context = {
        'tab': tab,
        'recipient_list': recipient_list
    }
    return render(request, template, context)


@inchar_required
def home(request):
    return generic_message_list(
        request,
        tab='new',
        recipient_list=request.hero.messagerecipient_set.filter(read=False)
    )


@inchar_required
def messages_list(request):
    return generic_message_list(
        request,
        tab='all',
        recipient_list=request.hero.messagerecipient_set.all()
    )


@inchar_required
def favourites_list(request):
    return generic_message_list(
        request,
        tab='favourites',
        recipient_list=request.hero.messagerecipient_set.filter(
            favourite=True
        )
    )


@inchar_required
def sent_list(request):
    context = {
        'tab': 'sent',
        'message_list': request.hero.messages_sent
    }
    return render(request, 'messaging/sent_list.html', context)

messaging/views/reply.py
from messaging.views.compose import ComposeView
from messaging.views.decorators import recipient_required_decorator


@recipient_required_decorator
def reply(request, recipient_id, prefilled_text=''):
    view = ComposeView()
    return view.get(
        request, reply_to=request.recipient, prefilled_text=prefilled_text)

messaging/templates/messaging/base.html
{% extends "base/base.html" %}

{% load extra_filters %}

{% block content %}

    <div>
        <h1 class="text-center">Messaging</h1>
    </div>

    <ul class="nav nav-tabs">
        <li role="presentation" {% if tab == 'new' %}class="active"{% endif %}>
            <a href="{% url 'messaging:home' %}"><span class="glyphicon glyphicon-asterisk" aria-hidden="true"></span> New</a>
        </li>
        <li role="presentation" {% if tab == 'compose' %}class="active"{% endif %}>
            <a href="{% url 'messaging:compose' %}"><span class="glyphicon glyphicon-pencil" aria-hidden="true"></span> Compose</a>
        </li>
        <li role="presentation" {% if tab == 'favourites' %}class="active"{% endif %}>
            <a href="{% url 'messaging:favourites' %}"><span class="glyphicon glyphicon-star" aria-hidden="true"></span> Favourites</a>
        </li>
        <li role="presentation" {% if tab == 'sent' %}class="active"{% endif %}>
            <a href="{% url 'messaging:sent' %}"><span class="glyphicon glyphicon-send" aria-hidden="true"></span> Sent</a>
        </li>
        <li role="presentation" {% if tab == 'all' %}class="active"{% endif %}>
            <a href="{% url 'messaging:messages_list' %}">Archive</a>
        </li>
    </ul>

    {% if tab == 'new' %}
        <div>
            <br>
            <p class="text-center">
                <a
                        class="btn btn-primary"
                        href="{% url 'messaging:mark_all_read'%}">Mark all as read</a>
            </p>
        </div>
    {% endif %}

    {% block messaging_content %}
    {% endblock %}

{% endblock %}

messaging/templates/messaging/compose.html
{% extends "messaging/base.html" %}

{% block messaging_content %}

    <form class="form-horizontal" role="form" method="post" action="{% url 'messaging:compose' %}">
        {% csrf_token %}
        <div class="col-lg-5">
            {% if reply_to %}
                <legend>Original message</legend>
                {% include 'messaging/message_body.html' with message=reply_to.message %}
            {% endif %}

            <legend>Message body</legend>
            <div class="form-group">
                <textarea class="form-control"
                          name="message_body"
                          rows="20"
                          id="message_body"
                          placeholder="Enter your text here."
                          maxlength="10000"
                >{{ prefilled_text }}</textarea>
            </div>

            <button type="submit" class="btn btn-primary pull-right">Send</button>
        </div>
        <div class="col-lg-6 col-lg-offset-1">
            {% if target_character %}
                <legend>Sending to</legend>
                <input type="hidden" name="recipient" value="character_{{ target_character.id }}">
                <p>
                    {{ target_character.get_html_link|safe }}
                </p>
            {% elif reply_to %}
                <legend>Sending to</legend>
                <ul>
                    {% for recipient in reply_to.message.get_nice_recipient_list %}
                        <li>{{ recipient.get_html_link|safe }}</li>
                    {% endfor %}
                </ul>

                <input type="hidden" name="reply_to" value="{{ reply_to.id }}">
            {% else %}
                <legend>Recipients by geography</legend>

                <div class="form-group">
                    <input type="checkbox" name="recipient" id="recipient_settlement" value="settlement">
                    <label for="recipient_settlement">Everyone in {{ request.hero.location }} (local settlement)</label>
                    <br>
                    <input type="checkbox" name="recipient" id="recipient_region" value="region">
                    <label for="recipient_region">Everyone in {{ request.hero.location.tile }} (local region)</label>
                </div>

                <legend>Recipients by politics</legend>
                <div class="form-group">
                    {% comment %}
                    {% if request.hero.oath_sworn_to %}
                        <input type="checkbox" name="recipient" id="recipient_liege" value="character_{{ request.hero.oath_sworn_to.get_position_occupier.id }}">
                        <label for="recipient_liege">Your Liege ({{ request.hero.oath_sworn_to.get_html_link|safe }})</label>
                        <br>
                    {% endif %}
                    {% endcomment %}
                    {% for organization in request.hero.organization_set.all %}
                        {% if not organization.is_position %}
                            <input type="checkbox" name="recipient" id="recipient_organization_{{ organization.id }}" value="organization_{{ organization.id }}">
                            <label for="recipient_organization_{{ organization.id }}">All members of {{ organization.get_html_link|safe }}</label>
                            <br>

                            {% if organization.leader %}
                                <input type="checkbox" name="recipient" id="recipient_organization_{{ organization.leader.id }}" value="organization_{{ organization.leader.id }}">
                                <label for="recipient_organization_{{ organization.id }}">{{ organization.leader.get_html_link|safe }}, leader of {{ organization.get_html_link|safe }}</label>
                                <br>
                            {% endif %}
                            {% if organization.owner %}
                                <input type="checkbox" name="recipient" id="recipient_organization_{{ organization.owner.id }}" value="organization_{{ organization.owner.id }}">
                                <label for="recipient_organization_{{ organization.id }}">{{ organization.owner.get_html_link|safe }}, owner of {{ organization.get_html_link|safe }}</label>
                                <br>
                            {% endif %}

                        {% endif %}
                    {% endfor %}
                </div>

                <legend>Personal contacts</legend>
                <div class="form-group">
                    {% for relationship in request.hero.messagerelationship_set.all %}
                        <input type="checkbox" name="recipient" id="recipient_character_{{ relationship.to_character.id }}" value="character_{{ relationship.to_character.id }}">
                        <label for="recipient_character_{{ relationship.to_character.id }}">{{ relationship.to_character.get_html_link|safe }}</label>
                        <a href="{% url 'messaging:remove_contact' relationship.to_character.id %}">
                            <span class="text-danger"><span class="glyphicon glyphicon-remove-sign" aria-hidden="true"></span></span>
                        </a>
                        {% if not forloop.last %}<br>{% endif %}
                    {% empty %}
                        None available. To add characters here, visit a charachter's page.
                    {% endfor %}
                </div>
            {% endif %}
        </div>
    </form>

{% endblock %}

messaging/templates/messaging/message_body.html
{{ message.content|safe }}

messaging/templates/messaging/message_include.html
<div class="panel panel-default">
    <div class="panel-heading">
        <span class="lead">
            {% if recipient.message.sender %}
                Message from {{ recipient.message.sender.get_html_link|safe }}
            {% else %}
                {{ recipient.message.get_category_display|capfirst }}
            {% endif %}
            {% if recipient.message.link %}
                <a
                        href="{{ recipient.message.link }}"
                        class="btn btn-primary btn-sm"
                >
                    View
                </a>
            {% endif %}
        </span>
        {% if recipient.message.sender %}
            <a
                    href="{% url 'messaging:reply' recipient.id %}"
                    class="btn btn-sm btn-primary pull-right">
                <span class="glyphicon glyphicon-comment" aria-hidden="true"></span> reply
            </a>
        {% endif %}

        <a
                href="{{ recipient.get_mark_read_url }}"
                class="btn btn-sm {% if recipient.read %}btn-success{% else %}btn-default{% endif %} pull-right"
        >
            <span class="glyphicon glyphicon-ok" aria-hidden="true"></span>
        </a>

        <a
                href="{{ recipient.get_mark_favourite_url }}"
                class="btn btn-sm {% if recipient.favourite %}btn-success{% else %}btn-default{% endif %} pull-right">
            <span class="glyphicon glyphicon-star" aria-hidden="true"></span>
        </a>

    </div>
    <div class="panel-body">
        <div class="row">
            {% if recipient.message.sender %}
                <p class="small">
                    For
                    {% for message_recipient in recipient.message.get_nice_recipient_list %}{% if not forloop.first and forloop.last %} and {% elif not forloop.first %}, {% endif %}{{ message_recipient.get_html_link|safe }}{% if forloop.last %}.{% endif %}
                    {% empty %}
                        NOONE?.
                    {% endfor %}
                </p>
            {% endif %}
            <p class="small text-right">
                {{ recipient.message.creation_time }}
            </p>
        </div>
        {% include 'messaging/message_body.html' with message=recipient.message %}
    </div>
</div>

messaging/templates/messaging/message_list.html
{% extends "messaging/base.html" %}

{% load extra_filters %}

{% block messaging_content %}

    <div>

        {% for recipient in recipient_list %}
            {% ifchanged %}
                <hr>
                <div class="row">
                    <h5>
                        {{ recipient.message.creation_turn|nice_turn }}
                    </h5>
                </div>
            {% endifchanged %}

            <div class="row">
                <div class="col-lg-8 col-lg-offset-2">
                    {% include 'messaging/message_include.html' %}
                </div>
            </div>
        {% empty %}
            <p>
                No messages.
            </p>
        {% endfor %}
    </div>

{% endblock %}

messaging/templates/messaging/sent_list.html
{% extends "messaging/base.html" %}

{% load extra_filters %}

{% block messaging_content %}

    <div>

        {% for message in message_list.all %}
            {% ifchanged %}
                <hr>
                <div class="row">
                    <h5>
                        {{ message.creation_turn|nice_turn }}
                    </h5>
                </div>
            {% endifchanged %}

            <div class="row">
                <div class="col-lg-8 col-lg-offset-2">

                    <div class="panel panel-default">
                        <div class="panel-heading">
                            <span class="lead">
                                Sent to
                                {% for message_recipient in message.get_nice_recipient_list %}{% if not forloop.first and forloop.last %} and {% elif not forloop.first %}, {% endif %}{{ message_recipient.get_html_link|safe }}
                                {% empty %}
                                    NOONE?.
                                {% endfor %}
                            </span>
                        </div>
                        <div class="panel-body">
                            <p class="text-right">
                                <small>{{ message.creation_time }}</small>
                            </p>
                            {% include 'messaging/message_body.html' with message=message %}
                        </div>
                    </div>
                </div>
            </div>
        {% empty %}
            <p>
                No messages.
            </p>
        {% endfor %}
    </div>

{% endblock %}